/* $Id: th001.c 91 2004-09-16 15:02:07Z /CN=thome/emailAddress=thome@loria.fr $ */

#include <stdio.h>
#include <stdlib.h>
#include <gmp.h>
#include <math.h>
#include <assert.h>
#include <string.h>
#include <stdlib.h>

#include "mploc.h"
#include "z2.h"
#include "z2x.h"
#include "z2n.h"

#define	INFO(x)	\
	printf(#x " : alloc=%d ; prec=%lu ; deg=%d ; cw=%lu\n",	\
			(x)->alloc, (x)->prec, (x)->deg, (x)->cw)

int main(int argc, char *argv[])
{
	mplf_t z2x;
	mploc_z2x_t a,b,r;
	int ok;

	z2x = mplf_z2_create();
	mploc_z2x_init(a, z2x);
	mploc_z2x_init(b, z2x);
	mploc_z2x_init(r, z2x);

	mploc_z2x_realloc(a,1,2,95);
	mploc_z2x_realloc(b,1,2,95);
	mploc_z2x_realloc(r,1,4,32);
	// INFO(a);
	// INFO(b);

	/* change the precision */
	mploc_z2x_realloc(a,1,2,32);
	mploc_z2x_realloc(b,1,2,65);
	// INFO(a);
	// INFO(b);

	mploc_z2x_set_coeff_ui(r,4,2004002);
	mploc_z2x_set_coeff_ui(r,3,64064);
	mploc_z2x_set_coeff_ui(r,2,32472);
	mploc_z2x_set_coeff_ui(r,2,32472);
	mploc_z2x_set_coeff_ui(r,1,440);
	mploc_z2x_set_coeff_ui(r,0,110);

	mploc_z2x_set_coeff_ui(a,2,1001);
	mploc_z2x_set_coeff_ui(a,1,22);
	mploc_z2x_set_coeff_ui(a,0,11);

	mploc_z2x_set_coeff_ui(b,2,2002);
	mploc_z2x_set_coeff_ui(b,1,20);
	mploc_z2x_set_coeff_ui(b,0,10);

	/*
	INFO(a);
	INFO(b);
	printf("a="); mploc_z2x_print(a); printf("\n");
	printf("b="); mploc_z2x_print(b); printf("\n");
	*/

	mploc_z2x_mul(a,a,b);

	/*
	INFO(a);
	INFO(b);
	printf("a="); mploc_z2x_print(a); printf("\n");
	printf("b="); mploc_z2x_print(b); printf("\n");
	*/

	ok=mploc_z2x_eq(r,a);

	mploc_z2x_clear(r);
	mploc_z2x_clear(a);
	mploc_z2x_clear(b);
	mplf_z2_destroy(&z2x);
	
	return ok?0:-1;
}
