/* $Id: th004.c 101 2004-09-17 15:28:03Z /CN=thome/emailAddress=thome@loria.fr $ */

#include <stdio.h>
#include <stdlib.h>
#include <gmp.h>
#include <math.h>
#include <assert.h>
#include <string.h>
#include <stdlib.h>

#include "mploc.h"
#include "z2.h"
#include "z2x.h"
#include "z2n.h"

int main(int argc, char *argv[])
{
	mp_size_t precision;
	int n;
	mploc_z2x_t V, res;
	mplf_t field;
	mploc_t aux1, aux2;
	int i, j;

	precision = 191;
	n = 3;

	/* PK<X> := PolynomialRing(Integers());
	 */

	field = mplf_z2_create();
	mploc_z2x_init(V, field);
	mploc_z2x_init(res, field);
	mploc_z2_init(aux1, field);
	mploc_z2_init(aux2, field);

	/* res := 0;
	 */
	mploc_z2x_set_ui(res, 0, precision);

	/*
V := 27648950770976413453412792543*X + 27648950770976413453412792543*X^2\
     + 39614081257132168796771975167*X^3;
	 */
	mploc_z2x_set_ui(V, 0, precision);
/* 27648950770976413453412792543 eq (10078801*3978956 + 3)*3889163*177273779;
	 */
	mploc_z2_set_ui(aux1, 10078801, precision);
	mploc_z2_set_ui(aux2, 3978956, precision);
	mploc_z2_mul(aux1, aux1, aux2);
	mploc_z2_add_ui(aux1, aux1, 3);
	mploc_z2_set_ui(aux2, 3889163, precision);
	mploc_z2_mul(aux1, aux1, aux2);
	mploc_z2_set_ui(aux2, 177273779, precision);
	mploc_z2_mul(aux1, aux1, aux2);
	mploc_z2x_set_coeff(V, 1, aux1);
	mploc_z2x_set_coeff(V, 2, aux1);
/* 39614081257132168796771975167 eq (17735177*1710 + 1)*420778751*524287*5921;
	 */
	mploc_z2_set_ui(aux1, 17735177, precision);
	mploc_z2_set_ui(aux2, 1710, precision);
	mploc_z2_mul(aux1, aux1, aux2);
	mploc_z2_add_ui(aux1, aux1, 1);
	mploc_z2_set_ui(aux2, 420778751, precision);
	mploc_z2_mul(aux1, aux1, aux2);
	mploc_z2_set_ui(aux2, 524287, precision);
	mploc_z2_mul(aux1, aux1, aux2);
	mploc_z2_set_ui(aux2, 5921, precision);
	mploc_z2_mul(aux1, aux1, aux2);
	mploc_z2x_set_coeff(V, 3, aux1);

	// mploc_z2x_print(V); printf("\n");
	/*
	   for(i=0;i<=V->deg;i++) {
	   for(j=0;j<V->cw;j++) {
	   printf("%s0x%08lx", j?" ":"", V->c[V->cw*i+j]);
	   }
	   printf("\n");
	   }
	 */

	/* V := 2^96*V;
	 */
	mploc_z2x_lshift(res, V, 3 * GMP_LIMB_BITS);

	// mploc_z2x_print(res); printf("\n");
	for (i = 0; i <= res->deg; i++) {
		for (j = 0; j < V->cw; j++) {
			if (res->c[res->cw * i + j + 3] !=
			    V->c[V->cw * i + j]) {
				exit(1);
			}
#if 0
			printf("%s0x%08lx", j ? " " : "",
			       res->c[res->cw * i + j + 3] ^ V->c[V->cw * i +
								  j]
			    );
#endif
		}
#if 0
		printf("\n");
#endif
	}

	mploc_z2x_clear(V);
	mploc_z2x_clear(res);
	mploc_z2_clear(aux1);
	mploc_z2_clear(aux2);
	return 0;
}
