/* $Id: reduce.c 205 2006-09-29 14:42:37Z /CN=thome/emailAddress=thome@loria.fr $ */

#ifdef	HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <gmp.h>
#ifdef  HAVE_GMP_GMP_MPARAM_H
#include <gmp/gmp-mparam.h>
#elif defined(HAVE_GMP_MPARAM_H)
#include <gmp-mparam.h>
#endif

#include <assert.h>
#include <string.h>

#include "manu.h"

#include "mploc.h"
#include "z2.h"
#include "z2x.h"
#include "z2n.h"
#include "z2_limbs.h"

#include "irr_tbl.h"

#define	DEFAULT_DEG		8

mplf_t z2;

void usage(int rc)
{
	fprintf(stderr, "Usage: reduce <deg> <target deg> [<prec>]\n");
	exit(rc);
}


int main(int argc, char * argv[])
{
	mploc_z2x_t f,g;
	int deg=DEFAULT_DEG;
	int prec=GMP_LIMB_BITS;
	int p;

	setvbuf(stdout, NULL, _IONBF, 0);
	setvbuf(stderr, NULL, _IONBF, 0);

	z2 = mplf_z2_create();
	mploc_z2x_init(f, z2);

	for(p=0;argc>1;argv++,argc--) {
		if (strcmp(argv[1],"--help")==0) {
			usage(0);
		}
		mp_size_t v=atoi(argv[1]);
		if (v==0) usage(1);
		switch (p++) {
			case 0: deg=v; break;
			case 1: prec=v; break;
			default: usage(1);
		}
	}

	if (!mploc_z2x_set_irrpol_db_quick(f,deg)) {
		fprintf(stderr,"Degree %d poly is not in irr_tbl\n", deg);
		exit(1);
	}

	mploc_z2x_force_precision(f,GMP_LIMB_BITS);
	printf("f:=");
	mploc_z2x_print(f);
	printf(";\n");

	mploc_z2x_init(g,z2);
	mploc_z2x_preinv(g,f);
	printf("g:=");
	mploc_z2x_print(g);
	printf(";\n");

	REALLOC_INFO();

	mploc_z2x_clear(f);
	mploc_z2x_clear(g);
	mplf_z2_destroy(&z2);

	return 0;
}
