#ifndef GENERIC_H_
#define GENERIC_H_

/* This file contains all asm inlines which are in fact full C code.
 * Sometimes they're better than anything.
 */

ASM_FUNCTION(MUL1,__c0)
INLINER void MUL1__c0(mp_limb_t * r,const mp_limb_t * s1,const mp_limb_t * s2)
{
	r[0]=s1[0]*s2[0];
}

ASM_FUNCTION(ADDMUL1,__c0)
INLINER void ADDMUL1__c0(mp_limb_t * r,const mp_limb_t * s1,const mp_limb_t * s2)
{
	r[0]+=s1[0]*s2[0];
}

ASM_FUNCTION(SQR1,__c0)
INLINER void SQR1__c0(mp_limb_t * t,const mp_limb_t * s)
{
	*t=*s**s;
}

#include <string.h>

#define	FULLC_MUL_CODE(WIDTH)	\
	ASM_FUNCTION(MUL ## WIDTH,__fullc)		\
	static inline void MUL ## WIDTH ## __fullc(	\
			mp_limb_t * c,			\
			const mp_limb_t * a,		\
			const mp_limb_t *b)		\
	{						\
		mp_limb_t t[2*WIDTH];			\
		mpn_mul_n(t,a,b,WIDTH);			\
		memcpy(c,t,WIDTH*sizeof(mp_limb_t));	\
	}

#define	FULLC_ADDMUL_CODE(WIDTH)	\
	ASM_FUNCTION(ADDMUL ## WIDTH,__fullc)		\
	static inline void ADDMUL ## WIDTH ## __fullc(	\
			mp_limb_t * c,			\
			const mp_limb_t * a,		\
			const mp_limb_t * b)		\
	{						\
		mp_limb_t t[2*WIDTH];			\
		mpn_mul_n(t,a,b,WIDTH);			\
		mpn_add_n(c,c,t,WIDTH);	\
	}

#define	FULLC_SQR_CODE(WIDTH)	\
	ASM_FUNCTION(SQR ## WIDTH,__fullc)		\
	static inline void SQR ## WIDTH ## __fullc(	\
			mp_limb_t * c,			\
			const mp_limb_t * a)		\
	{						\
		mp_limb_t t[2*WIDTH];			\
		mpn_mul_n(t,a,a,WIDTH);			\
		memcpy(c,t,WIDTH*sizeof(mp_limb_t));	\
	}

#define	FULLC_SQRc_CODE(WIDTH)	\
	ASM_FUNCTION(SQR ## WIDTH ## c,__fullc)	\
	static inline mp_limb_t SQR ## WIDTH ## c__fullc(	\
			mp_limb_t * c,			\
			const mp_limb_t * a)		\
	{						\
		mp_limb_t t[2*WIDTH];			\
		mpn_mul_n(t,a,a,WIDTH);			\
		memcpy(c,t,WIDTH*sizeof(mp_limb_t));	\
		return t[WIDTH] & (mp_limb_t) 1UL;	\
	}

FULLC_MUL_CODE(1)
FULLC_MUL_CODE(2)
FULLC_MUL_CODE(3)
FULLC_MUL_CODE(4)
FULLC_MUL_CODE(5)
FULLC_MUL_CODE(6)
FULLC_MUL_CODE(7)
FULLC_MUL_CODE(8)
FULLC_ADDMUL_CODE(1)
FULLC_ADDMUL_CODE(2)
FULLC_ADDMUL_CODE(3)
FULLC_ADDMUL_CODE(4)
FULLC_SQR_CODE(1)
FULLC_SQR_CODE(2)
FULLC_SQR_CODE(3)
FULLC_SQR_CODE(4)
FULLC_SQRc_CODE(1)
FULLC_SQRc_CODE(2)
FULLC_SQRc_CODE(3)
FULLC_SQRc_CODE(4)

#endif	/* GENERIC_H_ */
