/* $Id: gmp_hacks.h 205 2006-09-29 14:42:37Z /CN=thome/emailAddress=thome@loria.fr $ */

#ifndef GMP_HACKS_H_
#define GMP_HACKS_H_

#ifdef	HAVE_GMP_GMP_MPARAM_H
#include <gmp/gmp-mparam.h>
#elif defined(HAVE_GMP_MPARAM_H)
#include <gmp-mparam.h>
#endif

#include "manu.h"

#ifndef ABS
#define ABS(x) ((x) >= 0 ? (x) : -(x))
#endif
#ifndef MIN
#define MIN(l,o) ((l) < (o) ? (l) : (o))
#endif
#ifndef MAX
#define MAX(h,i) ((h) > (i) ? (h) : (i))
#endif
#define numberof(x)  (sizeof (x) / sizeof ((x)[0]))

/* Field access macros.  */
#define SIZ(x) ((x)->_mp_size)
#define ABSIZ(x) ABS (SIZ (x))
#define PTR(x) ((x)->_mp_d)
#define LIMBS(x) ((x)->_mp_d)
#define EXP(x) ((x)->_mp_exp)
#define PREC(x) ((x)->_mp_prec)
#define ALLOC(x) ((x)->_mp_alloc)


#ifndef MPN_NORMALIZE
#define MPN_NORMALIZE(DST, NLIMBS) \
  do {                                                                  \
    while ((NLIMBS) > 0)                                                \
      {                                                                 \
        if ((DST)[(NLIMBS) - 1] != 0)                                   \
          break;                                                        \
        (NLIMBS)--;                                                     \
      }                                                                 \
  } while (0)
#endif

/* Useful for the lazy boyz */
#define MPZ_INIT_SET_MPN(DST, SRC, NLIMBS)			\
	BEGIN_BLOCK						\
	(DST)->_mp_alloc = (NLIMBS);				\
	(DST)->_mp_size = (NLIMBS);					\
	(DST)->_mp_d = malloc((NLIMBS) * sizeof(mp_limb_t));	\
	memcpy((DST)->_mp_d,(SRC),(NLIMBS) * sizeof(mp_limb_t));	\
	MPN_NORMALIZE((DST)->_mp_d,(DST)->_mp_size);		\
	END_BLOCK
	
#define MPZ_SET_MPN(DST, SRC, NLIMBS)				\
	BEGIN_BLOCK						\
	if ((DST)->_mp_alloc < (NLIMBS)) {			\
		(DST)->_mp_alloc = (NLIMBS);			\
		(DST)->_mp_d=realloc((DST)->_mp_d,(NLIMBS)*sizeof(mp_limb_t)); \
	}							\
	(DST)->_mp_size = (NLIMBS);					\
	memcpy((DST)->_mp_d,(SRC),(NLIMBS) * sizeof(mp_limb_t));	\
	MPN_NORMALIZE((DST)->_mp_d,(DST)->_mp_size);		\
	END_BLOCK
	   
#define MPN_SET_MPZ(DST,NLIMBS,SRC)				\
	BEGIN_BLOCK						\
	memcpy((DST),(SRC)->_mp_d,(SRC)->_mp_size * sizeof(mp_limb_t));	\
	memset((DST)+(SRC)->_mp_size,0,((NLIMBS)-(SRC)->_mp_size) * sizeof(mp_limb_t));\
	END_BLOCK

#define MPN_ADD_MPZ(DST,NLIMBS,SRC)				\
	BEGIN_BLOCK						\
	mpn_add((DST), (DST), (NLIMBS), (SRC)->_mp_d, (SRC)->_mp_size);	\
	END_BLOCK



#endif /* GMP_HACKS_H_ */	
