/* $Id: z2.h 182 2004-10-12 17:25:18Z /CN=thome/emailAddress=thome@loria.fr $ */

#ifndef Z2_H_
#define Z2_H_

#ifdef __cplusplus
extern "C" {
#endif

extern mplf_t mplf_z2_create();
extern void mplf_z2_destroy(mplf_t * pf);
extern void mplf_z2_tell_logp(mplf_t, double);
extern void mploc_z2_force_precision(mploc_ptr, mp_size_t);
extern void mploc_z2_init(mploc_ptr, mplf_t);
extern void mploc_z2_set_change_precision(mploc_ptr, mploc_srcptr, mp_size_t);
extern void mploc_z2_set(mploc_ptr, mploc_srcptr);
extern void mploc_z2_set_ui(mploc_ptr, mp_limb_t, unsigned int);
extern void mploc_z2_set_mpz(mploc_ptr, mpz_srcptr, unsigned int);
extern void mploc_z2_set_random(mploc_ptr, gmp_randstate_t, unsigned int);
extern void mploc_z2_add(mploc_ptr, mploc_srcptr, mploc_srcptr);
extern void mploc_z2_add_ui(mploc_ptr, mploc_srcptr, mp_limb_t);
extern void mploc_z2_sub(mploc_ptr, mploc_srcptr, mploc_srcptr);
extern void mploc_z2_sub_ui(mploc_ptr, mploc_srcptr, mp_limb_t);
extern void mploc_z2_normalize(mploc_ptr);
extern void mploc_z2_mul(mploc_ptr, mploc_srcptr, mploc_srcptr);
extern void mploc_z2_sqr(mploc_ptr, mploc_srcptr);
extern void mploc_z2_inv(mploc_ptr, mploc_srcptr);
extern int mploc_z2_invsqrt(mploc_ptr, mploc_srcptr);
extern int mploc_z2_sqrt(mploc_ptr, mploc_srcptr);
extern void mploc_z2_clear(mploc_ptr);
extern void mploc_z2_print(mploc_srcptr);
extern int mploc_z2_valuation(mploc_srcptr);
extern int mploc_z2_eq(mploc_srcptr, mploc_srcptr);
extern int mploc_z2_eq_ui(mploc_srcptr, mp_limb_t);
#define mploc_z2_is_zero(x)	(mploc_z2_eq_ui((x),0))
#define mploc_z2_is_one(x)	(mploc_z2_eq_ui((x),1))
extern void mploc_z2_lshift(mploc_ptr, mploc_srcptr, mp_size_t);
extern void mploc_z2_rshift(mploc_ptr, mploc_srcptr, mp_size_t);
extern int mploc_z2_is_good_looking(mploc_srcptr);
extern void mploc_z2_neg(mploc_ptr, mploc_srcptr);
extern void mploc_z2_trace(mploc_ptr, mploc_srcptr);


#ifdef __cplusplus
}
#endif

#endif	/* Z2_H_ */
