/* $Id: z2x.h 196 2004-10-14 16:07:44Z /CN=thome/emailAddress=thome@loria.fr $ */

#ifndef Z2X_H_
#define Z2X_H_

#ifdef __cplusplus
extern "C" {
#endif

/* NOTE : At present, almost all functions are listed here. I haven't
 * cared to distinguish between ``public'' and ``private'' ones (but I
 * intend to, eventually).
 */
extern void mploc_z2x_init(mploc_z2x_ptr, mplf_t);
extern void mploc_z2x_clear(mploc_z2x_ptr);

extern int mploc_z2x_is_good_looking_maybe_nonnormal(mploc_z2x_srcptr);
extern int mploc_z2x_is_good_looking(mploc_z2x_srcptr);

extern void mploc_z2x_chop_deg(mploc_z2x_ptr, mp_size_t);
extern void mploc_z2x_force_precision(mploc_z2x_ptr, mp_size_t);
extern void mploc_z2x_normalize(mploc_z2x_ptr);

extern void mploc_z2x_clobber(mploc_z2x_ptr);
extern int  mploc_z2x_realloc(mploc_z2x_ptr, int, mp_size_t, mp_size_t);

extern void mploc_z2x_insert_zero(mploc_z2x_ptr, mp_size_t);
extern void mploc_z2x_sign_extend(mploc_z2x_ptr x, mp_size_t k);

extern void mploc_z2x_set_change_precision(mploc_z2x_ptr, mploc_z2x_srcptr, mp_size_t);
extern void mploc_z2x_set(mploc_z2x_ptr, mploc_z2x_srcptr);
extern void mploc_z2x_set_xi(mploc_z2x_ptr, mp_size_t, mp_size_t);
extern void mploc_z2x_set_coeff(mploc_z2x_ptr, mp_size_t, mploc_srcptr);
extern void mploc_z2x_set_coeff_ui(mploc_z2x_ptr, mp_size_t, mp_limb_t);
extern int mploc_z2x_coeff_eq_ui(mploc_z2x_srcptr, mp_size_t, mp_limb_t);
extern void mploc_z2x_set_ui(mploc_z2x_ptr, mp_limb_t, mp_size_t);
extern void mploc_z2x_set_mpz(mploc_z2x_ptr, mpz_srcptr, mp_size_t);
extern void mploc_z2x_set_random(mploc_z2x_ptr, gmp_randstate_t, mp_size_t, mp_size_t);

extern void mploc_z2x_get_coeff(mploc_ptr, mploc_z2x_srcptr, mp_size_t);

extern void mploc_z2x_add(mploc_z2x_ptr, mploc_z2x_srcptr, mploc_z2x_srcptr);
extern void mploc_z2x_add_ui(mploc_z2x_ptr, mploc_z2x_srcptr, mp_limb_t);
extern void mploc_z2x_sub(mploc_z2x_ptr, mploc_z2x_srcptr, mploc_z2x_srcptr);
extern void mploc_z2x_sub_ui(mploc_z2x_ptr, mploc_z2x_srcptr, unsigned long);
extern void mploc_z2x_neg(mploc_z2x_ptr, mploc_z2x_srcptr);

extern void mploc_z2x_mul_xi(mploc_z2x_ptr, mploc_z2x_srcptr, mp_size_t);
extern void mploc_z2x_div_q_xi(mploc_z2x_ptr, mploc_z2x_srcptr, mp_size_t);
extern void mploc_z2x_div_r_xi(mploc_z2x_ptr, mploc_z2x_srcptr, mp_size_t);
extern void mploc_z2x_mul_z2(mploc_z2x_ptr, mploc_z2x_srcptr, mploc_srcptr);

extern void mploc_z2x_print(mploc_z2x_srcptr);
extern int mploc_z2x_valuation(mploc_z2x_srcptr);
extern void mploc_z2x_lshift(mploc_z2x_ptr, mploc_z2x_srcptr, mp_size_t);
extern void mploc_z2x_lshift_quick(mploc_z2x_ptr, mploc_z2x_srcptr, mp_size_t);
extern void mploc_z2x_rshift(mploc_z2x_ptr, mploc_z2x_srcptr, mp_size_t);
extern void mploc_z2x_mul(mploc_z2x_ptr, mploc_z2x_srcptr, mploc_z2x_srcptr);
extern void mploc_z2x_reversal(mploc_z2x_ptr, mploc_z2x_srcptr, mp_size_t);
#define	mploc_z2x_reciprocal(d,s)	mploc_z2x_reversal((d),(s),(s)->deg)
extern void mploc_z2x_preinv(mploc_z2x_ptr, mploc_z2x_srcptr);
extern void mploc_z2x_series_inv(mploc_z2x_ptr, mploc_z2x_srcptr, mp_size_t);
extern void mploc_z2x_div(mploc_z2x_ptr, mploc_z2x_ptr, mploc_z2x_srcptr, mploc_z2x_srcptr);
extern void mploc_z2x_sqr(mploc_z2x_ptr, mploc_z2x_srcptr);

extern int mploc_z2x_eq(mploc_z2x_srcptr, mploc_z2x_srcptr);
extern int mploc_z2x_eq_ui(mploc_z2x_srcptr, mp_limb_t);

#define mploc_z2x_degree(x)	((x)->deg)
#define mploc_z2x_is_zero(x)	(mploc_z2x_eq_ui((x),0)==0)
#define mploc_z2x_is_one(x)	(mploc_z2x_eq_ui((x),1)==0)

#ifdef	TUNING
extern void z2x_set_kara_mul_threshold(int);
extern void z2x_set_kara_sqr_threshold(int);
#else
#define	z2x_set_kara_mul_threshold(x)
#define	z2x_set_kara_sqr_threshold(x)
#endif

#ifdef __cplusplus
}
#endif

#endif	/* Z2X_H_ */
