/* $Id: zp.h 182 2004-10-12 17:25:18Z /CN=thome/emailAddress=thome@loria.fr $ */

#ifndef ZP_H_
#define ZP_H_

#ifdef __cplusplus
extern "C" {
#endif

extern mplf_t mplf_zp_create(mpz_srcptr p);
extern void mplf_zp_destroy(mplf_t * pf);
extern void mplf_zp_tell_logp(mplf_t, double);
extern void mploc_zp_force_precision(mploc_ptr, mp_size_t);
extern void mploc_zp_init(mploc_ptr, mplf_t);
extern void mploc_zp_set_change_precision(mploc_ptr, mploc_srcptr, mp_size_t);
extern void mploc_zp_set(mploc_ptr, mploc_srcptr);
extern void mploc_zp_set_ui(mploc_ptr, mp_limb_t, unsigned int);
extern void mploc_zp_set_mpz(mploc_ptr, mpz_srcptr, unsigned int);
extern void mploc_zp_set_random(mploc_ptr, gmp_randstate_t, unsigned int);
extern void mploc_zp_add(mploc_ptr, mploc_srcptr, mploc_srcptr);
extern void mploc_zp_add_ui(mploc_ptr, mploc_srcptr, mp_limb_t);
extern void mploc_zp_sub(mploc_ptr, mploc_srcptr, mploc_srcptr);
extern void mploc_zp_sub_ui(mploc_ptr, mploc_srcptr, mp_limb_t);
extern void mploc_zp_normalize(mploc_ptr);
extern void mploc_zp_mul(mploc_ptr, mploc_srcptr, mploc_srcptr);
extern void mploc_zp_sqr(mploc_ptr, mploc_srcptr);
extern void mploc_zp_inv(mploc_ptr, mploc_srcptr);
extern int mploc_zp_invsqrt(mploc_ptr, mploc_srcptr);
extern int mploc_zp_sqrt(mploc_ptr, mploc_srcptr);
extern void mploc_zp_clear(mploc_ptr);
extern void mploc_zp_print(mploc_srcptr);
extern int mploc_zp_valuation(mploc_srcptr);
extern int mploc_zp_eq(mploc_srcptr, mploc_srcptr);
extern int mploc_zp_eq_ui(mploc_srcptr, mp_limb_t);
#define mploc_zp_is_zero(x)	(mploc_zp_eq_ui((x),0))
#define mploc_zp_is_one(x)	(mploc_zp_eq_ui((x),1))
extern int mploc_zp_is_good_looking(mploc_srcptr);
extern void mploc_zp_neg(mploc_ptr, mploc_srcptr);
extern void mploc_zp_lshift(mploc_ptr, mploc_srcptr, mp_size_t);
extern void mploc_zp_rshift(mploc_ptr, mploc_srcptr, mp_size_t);
extern void mploc_zp_inversion_configure(int new_method, int new_seed);

extern mpz_srcptr p_to_the(int n, mplf_t f);
extern mploc_srcptr one_half(mplf_t f, int n);


#ifdef __cplusplus
}
#endif

#endif	/* ZP_H_ */
