/* $Id: zpx.h 91 2004-09-16 15:02:07Z /CN=thome/emailAddress=thome@loria.fr $ */

#ifndef ZPX_H_
#define ZPX_H_

#ifdef __cplusplus
extern "C" {
#endif

extern void mploc_zpx_init(mploc_zpx_ptr, mplf_t);
extern void mploc_zpx_clear(mploc_zpx_ptr);

extern int mploc_zpx_is_good_looking_maybe_nonnormal(mploc_zpx_srcptr);
extern int mploc_zpx_is_good_looking(mploc_zpx_srcptr);

// extern void mploc_zpx_extend(mploc_zpx_ptr, mp_size_t, mp_size_t);
extern void mploc_zpx_force_precision(mploc_zpx_ptr, mp_size_t);
// extern void mploc_zpx_allow_deg(mploc_zpx_ptr, mp_size_t);
extern void mploc_zpx_normalize(mploc_zpx_ptr);
// extern void mploc_zpx_shrink_tuned(mploc_zpx_ptr, mp_size_t, mp_size_t);
// extern void mploc_zpx_shrink(mploc_zpx_ptr);

extern void mploc_zpx_clobber(mploc_zpx_ptr);
extern int  mploc_zpx_realloc(mploc_zpx_ptr, int, mp_size_t, mp_size_t);

extern void mploc_zpx_insert_zero(mploc_zpx_ptr, mp_size_t);

extern void mploc_zpx_set_change_precision(mploc_zpx_ptr, mploc_zpx_srcptr, mp_size_t);
extern void mploc_zpx_set(mploc_zpx_ptr, mploc_zpx_srcptr);
extern void mploc_zpx_set_xi(mploc_zpx_ptr, mp_size_t, mp_size_t);
extern void mploc_zpx_set_coeff(mploc_zpx_ptr, mp_size_t, mploc_srcptr);
extern void mploc_zpx_set_ui(mploc_zpx_ptr, mp_limb_t, mp_size_t);
extern void mploc_zpx_set_mpz(mploc_zpx_ptr, mpz_srcptr, mp_size_t);
extern void mploc_zpx_set_random(mploc_zpx_ptr, gmp_randstate_t, mp_size_t, mp_size_t);

extern void mploc_zpx_get_coeff(mploc_ptr, mploc_zpx_srcptr, mp_size_t);

extern void mploc_zpx_add(mploc_zpx_ptr, mploc_zpx_srcptr, mploc_zpx_srcptr);
extern void mploc_zpx_add_ui(mploc_zpx_ptr, mploc_zpx_srcptr, mp_limb_t);
extern void mploc_zpx_sub(mploc_zpx_ptr, mploc_zpx_srcptr, mploc_zpx_srcptr);
extern void mploc_zpx_sub_ui(mploc_zpx_ptr, mploc_zpx_srcptr, unsigned long);
extern void mploc_zpx_neg(mploc_zpx_ptr, mploc_zpx_srcptr);

extern void mploc_zpx_mul_xi(mploc_zpx_ptr, mploc_zpx_srcptr, mp_size_t);
extern void mploc_zpx_div_q_xi(mploc_zpx_ptr, mploc_zpx_srcptr, mp_size_t);
extern void mploc_zpx_div_r_xi(mploc_zpx_ptr, mploc_zpx_srcptr, mp_size_t);
extern void mploc_zpx_mul_zp(mploc_zpx_ptr, mploc_zpx_srcptr, mploc_srcptr);

extern void mploc_zpx_print(mploc_zpx_srcptr);
extern int mploc_zpx_valuation(mploc_zpx_srcptr);
extern void mploc_zpx_lshift(mploc_zpx_ptr, mploc_zpx_srcptr, mp_size_t);
extern void mploc_zpx_rshift(mploc_zpx_ptr, mploc_zpx_srcptr, mp_size_t);
extern void mploc_zpx_mul(mploc_zpx_ptr, mploc_zpx_srcptr, mploc_zpx_srcptr);
extern void mploc_zpx_div(mploc_zpx_ptr, mploc_zpx_ptr, mploc_zpx_srcptr, mploc_zpx_srcptr);
extern void mploc_zpx_sqr(mploc_zpx_ptr, mploc_zpx_srcptr);

extern int mploc_zpx_eq(mploc_zpx_srcptr, mploc_zpx_srcptr);
extern int mploc_zpx_eq_ui(mploc_zpx_srcptr, mp_limb_t);

#define mploc_zpx_degree(x)	((x)->deg)
#define mploc_zpx_is_zero(x)	(mploc_zpx_eq_ui((x),0)==0)
#define mploc_zpx_is_one(x)	(mploc_zpx_eq_ui((x),1)==0)


#ifdef __cplusplus
}
#endif

#endif	/* ZPX_H_ */
